; Simulador del TMS320C3x v2.1 - Proyecto de Fin de Carrera
; Ingenieria Tecnica de Telecomunicacin
; Rubn Alonso Alejandre - Joaqun Cubillo Arribas

; Ejemplo 3.- Multiplica dos matrices de nmeros enteros de 16 bits

;*** CODIGO ***************************************************************************
                .start  "CODIGO", 0x809802      ;Comienzo de la seccion de programa
                .sect   "CODIGO"
                .entry  PRACT3                  ;Punto de entrada

PRACT3          LDP     @DATOS                  ;Inicializa el registro DP
                LDI     @stack, SP              ;Inicializa el puntero de pila

                LDI     @MatrizA, AR0               ;AR0 apunta a la matriz A
                LDI     @MatrizB, AR1               ;AR1 apunta a la matriz B
                LDI     @MatrizC, AR2               ;AR2 apunta a la matriz C
                LDI     K, IR0                      ;Columnas de B
                LDI     N, IR1                      ;Columnas de A = filas de B
                LDI     M, AR4                      ;Filas de A
                CALL    PRODUCTO                    ;Llamada a la subrutina PRODUCTO
                IDLE

   ;*** SUBRUTINA PRODUCTO ***;
PRODUCTO        LDI     IR0, R0                 ;Almacena IRO(K) en RO porque IRO se necesita
                LDI     IR1, R1                 ;Almacena IR1(N) en R1 porque IR1 se necesita
                LDI     AR4, R2                 ;
                LDI     0, R3                  ;Puntero para moverse por MATRIZ A
                LDI     0, R4                   ;Puntero para moverse por MATRIZ B
                LDI     AR2, AR3

BUCLE           ;Aqui va cada una de las multiplicaciones
                MPYI3   R4, R1, IR0             ;Inicializa el puntero a la matriz A (IR0)
                LDI     R3, IR1                 ;Inicializa el puntero a la matriz B (IR1)

                LDI     R1, RC                  ;Carga el numero de iteraciones (N)
                SUBI    1, RC                   ;Decrementa RC para un n de iter. correcto
                LDI     0, R6                   ;Inicializa el registro acumulador
                RPTB    FINBUCLE                     ;Repite hasta FINBUCLE N veces
                MPYI3   *+AR0(IR0), *+AR1(IR1), R5   ;Multiplica el par de elementos correspondientes
                ADDI    R5,R6                   ;Acumula el resultado anterior en R6
                ADDI    1, IR0                  ;Apunta al siguiente elemento en la fila de A actual (R4)
FINBUCLE        ADDI    R0, IR1                 ;Apunta al siguiente elemento en la columna de B actual (R3)
                STI     R6, *AR3++              ;Almacena el elemento (R4,R3) de la matriz C en memoria

                ADDI    1, R3                   ;Pasa a la siguiente columna de C
                CMPI    R0,R3                   ;Comparamos R3 (col. en C) con R0 (K - n colum. C)
                BLO     MISMAFILA               ;Si es menor es que aun seguimos en la misma fila de C
                LDI     0, R3                   ;Carga 0 en R3 (apunta a columna 0)
                ADDI    1, R4                   ;Pasa a la siguiente fila de C
MISMAFILA       CMPI    R2,R4                   ;Comparamos R4 (fila en C) con R2 (M - n filas C)
                BLO     BUCLE                   ;Si es menor saltamos a <BUCLE>

FIN             RETSU                           ;Retorna de la subrutina
;*** DATOS ***********************************************************************

                .start "DATOS", 0x809C00        ;Comienzo de la seccion de datos
                .sect  "DATOS",
MATR_A         .word  1,2,3,4,5,6,7,8,9         ;Tabla de datos de entrada
MATR_B         .word  1,0,0,0,1,0,0,0,1
M               .set   3                        ;Numero de filas de matriz A
N               .set   3                        ;Numero de filas de matriz B
K               .set   3                        ;Numero de filas de matriz C
MATR_C         .space M*K                       ;Tamao de la tabla
MatrizA             .word MATR_A                ;Puntero a la matriz A
MatrizB             .word MATR_B                ;Puntero a la matriz B
MatrizC             .word MATR_C                ;Puntero a la matriz C (Resultado)

; Espacio de memoria para la pila
stack           .word $+1                       ;Comienzo de la pila
                .space 256                      ;Reserva 256 posiciones
                .end